package io.tswf.minecraft.blockventure.core.transmutation.transmute

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.gui.BlockventureScreenHandlerType
import io.tswf.minecraft.blockventure.core.transmutation.staticview.ScreenHandlerTypeStaticView
import io.tswf.transmutations.common.annotation.ClassReference
import io.tswf.transmutations.common.annotation.MethodDescription
import io.tswf.transmutations.common.constant.MethodName
import io.tswf.transmutations.transmute.annotation.AtReturn
import io.tswf.transmutations.transmute.annotation.Transmute
import io.tswf.transmutations.transmute.meta.MissingTargetStrategy
import net.minecraft.screen.ScreenHandlerType

@CompileStatic
class TransmutationScreenHandlerType {

    @Transmute(
            targetClass = @ClassReference(ScreenHandlerType),
            targetMethod = @MethodDescription(
                    name = MethodName.CLASS_INIT,
                    returnTypeClass = ClassReference.VOID,
                    parameterTypeClasses = []
            ),
            onMissing = MissingTargetStrategy.THROW
    )
    @AtReturn
    static void registerBlockventureDummyScreenHandlerType() {
        def dummyScreenHandlerType = ScreenHandlerTypeStaticView.callRegister("blockventure:blockventure_screen_handler", { syncId, player -> null })
        BlockventureScreenHandlerType.TYPE_HOLDER.set(dummyScreenHandlerType)
    }
}
